﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Windows.Media;

namespace WpfCustomControlLibrary7
{
    public class ColumnInfo
    { 
        public ColumnInfo()
        {

        }
       
        public string Name { get; set; }
        public DisplayType Type { get; set; }
        Brush color = Brushes.Black;
        private object cellValue = 10;
        public bool IsRequiredforSubscription { get; set; }

        public ObservableCollection<string> ComboData { get; set; }

        public Brush BorderColor
        {
            get
            {
                return color;
            }

            set
            {
                color = value;
                //RaisePropertyChanged("BorderColor");
            }
        }

        public object Value
        {
            get
            {
                return cellValue;
            }

            set
            {
                cellValue = value;
                //RaisePropertyChanged("Value");
            }
        }

        public ColumnInfo(string name, DisplayType type, CellInfo cellInfo, bool isRequiredforSubscription)
        {
            Name = name;
            Type = type;
            BorderColor = cellInfo.BorderColor;
            IsRequiredforSubscription = isRequiredforSubscription;
        }

        public ColumnInfo(string name, DisplayType type)
        {
            Name = name;
            Type = type;         
        }

        public ColumnInfo(string name, DisplayType type, ObservableCollection<string> comboData)
        {
            Name = name;
            Type = type;
            ComboData = comboData;
        }        
    }

    public enum DisplayType
    {
        TextBox,
        Button,
        TextBlock,
        ComboBox
    }    

    public class CellInfo
    {
        Brush color = Brushes.Black;
        //private object cellValue = 10;

        public Brush BorderColor
        {
            get
            {
                return color;
            }

            set
            {
                color = value;
                //RaisePropertyChanged("BorderColor");
            }
        }

        public CellInfo(Brush color)
        {
            BorderColor = color;
        }
    }
}
