﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Media;
using System.Windows;

namespace WpfCustomControlLibrary7
{
    //public class RowInfo_Old : IDataErrorInfo 
    //{
    //    public List<object> paramData = new List<object>();

    //    public List<object> ParameterData { get; set; }

    //    public ErrorType errorMsg { get; set; }

    //    public ObservableCollection<RowInfo_Old> rowData;

    //    public ObservableCollection<RowInfo_Old> GetData()
    //    {
    //        rowData = new ObservableCollection<RowInfo_Old>();

    //        paramData.Add("CV001");
    //        paramData.Add("Sample Description");
    //        paramData.Add("0");
    //        paramData.Add("Active");

    //        rowData.Add(new RowInfo_Old { ParameterData = paramData, errorMsg = ErrorType.HighValue });

    //        rowData.Add(new RowInfo_Old { ParameterData = paramData, errorMsg = ErrorType.HighValue });

    //        return rowData;
    //    }

    //    public string Error
    //    {
    //        get { throw new NotImplementedException(); }
    //    }

    //    public string this[string columnName]
    //    {
    //        get { throw new NotImplementedException(); }
    //    }
    //}

    //public enum ErrorType
    //{
    //    Warning,
    //    HighValue,
    //    LowValue,
    //    None
    //}

    public class CellData : INotifyPropertyChanged
    {
        public enum ErrorType
        {
            Normal,
            Warning,
            HighValue,
            LowValue,
            UnHealthy
        }

        Brush color;
        private object cellValue { get; set; }
        private ErrorType warning { get; set; }
       
        public Brush BorderColor
        {
            get
            {
                return color;
            }

            set
            {
                color = value;
                RaisePropertyChanged("BorderColor");
            }
        }

        public object Value
        {
            get
            {
                return cellValue;
            }

            set
            {
                cellValue = value;
                RaisePropertyChanged("Value");
            }
        }

        public ErrorType Warning
        {
            get
            {
                return warning;
            }

            set
            {
                warning = value;
                RaisePropertyChanged("Warning");
            }
        }      

        public CellData()
        {

        }

        public CellData(object value)
        {
            Value = value;
        }

        public CellData(Brush borderColor)
        {
            BorderColor = borderColor;          
        }

        public CellData(Brush borderColor, object value, ErrorType e)
        {
            BorderColor = borderColor;
            Value = value;
            Warning = e;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class RowInfo
    {
        public List<CellData> rowData = new List<CellData>();
        //public List<object> rowData = new List<object>();
    }
} 
